#!***********************************************************************************************************
#TEMPLATE(AppAutoSaver, ' TXA/TXD   '),FAMILY('ABC'),FAMILY('CW20')
#!-----------------------------------------------------------------------------------------------------------
#!  APP
#!-----------------------------------------------------------------------------------------------------------
#! TXA -    .
#! TXD -     .
#!-----------------------------------------------------------------------------------------------------------
#!
#!       TXA/TXD     ,
#!        .
#!
#!      EXTENSION- "AppAutoSaver".
#!
#!     TXA:       .
#! TXD        .
#!
#!         TXA/TXD .    
#!    WinRAR ( solid  RAR    ).
#!
#!      :
#!
#! %TxaFile    -  TXA
#! %TxaFolder  -  TXA
#! %TxdFile    -  TXD
#! %TxdFolder  -  TXD
#! %AppName    -  APP ( )
#! %AppFilder  -  APP
#! %FileList   -  -  TXA/TXD
#!
#!    ,      .
#! 
#!***********************************************************************************************************
#EXTENSION(AppAutoSaver_Activate, ' TXA/TXD   '),APPLICATION,FIRST
#!-----------------------------------------------------------------------------------------------------------
  #SHEET
    #TAB('  ')
      #!  
      #BOXED,WHERE(%False)
        #!
        #!     
        #!
        #PROMPT('',@N10),%AutoSaverEveryDate,DEFAULT(%False)
        #PROMPT('',@N10),%AutoSaverEveryTime,DEFAULT(%False)
        #!
        #!      Dictionary
        #!
        #PROMPT('',@N10),%AutoSaverDctFlag,DEFAULT(%True)
      #ENDBOXED
      #!
      #BOXED(''),AT(,20),SECTION
        #PROMPT('  APP', CHECK), %AutoSaverActive, AT(10), DEFAULT(%True)
      #ENDBOXED
      #ENABLE(%AutoSaverActive)
        #BOXED,SECTION
          #PROMPT('  ',OPTION),%AutoSaverEvery,AT(5,0,185,35),DEFAULT('1')
          #PROMPT(' ', RADIO),AT(10,10),VALUE('1')
          #PROMPT(' ',         RADIO),AT(10,20),VALUE('2')
          #ENABLE(%AutoSaverEvery = '2')
            #PROMPT('', SPIN(@N3,1,120,1)),%AutoSaverEveryMin,AT(60,20,35),DEFAULT(10)
            #DISPLAY('.'),AT(100,20)
          #ENDENABLE
        #ENDBOXED
        #PREPARE
          #IF(NOT ITEMS(%AutoSaverRunCmdAll))
            #CALL(%ResetRunCmd)
          #ENDIF
        #ENDPREPARE
        #BOXED('')
          #DISPLAY('  TXA/TXD,   ')
          #DISPLAY('   .')
          #DISPLAY('    WinRAR.')
        #ENDBOXED
        #BOXED('  ')
          #BUTTON(''),MULTI(%AutoSaverRunCmdAll, %AutoSaverRunCmd),INLINE,AT(,,,60)
            #PROMPT(':', @S255),%AutoSaverRunCmd,AT(5,17,190),PROMPTAT(5,5)
            #BOXED(''),SECTION
              #DISPLAY(' :'),AT(10,0)
              #DISPLAY('%TxaFile'),AT(10,15)
              #DISPLAY('-  TXA'),AT(60,15)
              #DISPLAY('%TxaFolder'),AT(10,25)
              #DISPLAY('-  TXA'),AT(60,25)
              #!
              #DISPLAY('%TxdFile'),AT(10,35)
              #DISPLAY('-  TXD'),AT(60,35)
              #DISPLAY('%TxdFolder'),AT(10,45)
              #DISPLAY('-  TXD'),AT(60,45)
              #!
              #DISPLAY('%AppName'),AT(10,55)
              #DISPLAY('-  APP ( )'),AT(60,55)
              #DISPLAY('%AppFilder'),AT(10,65)
              #DISPLAY('-  APP'),AT(60,65)
              #DISPLAY('%FileList'),AT(10,75)
              #DISPLAY('-  - TXA/TXD'),AT(60,75)
              #DISPLAY
              #DISPLAY('   ,  ')
              #DISPLAY('   .')
            #ENDBOXED
          #ENDBUTTON
        #ENDBOXED
        #BUTTON('C'),AT(150,,40),WHENACCEPTED(%ResetRunCmd())
        #ENDBUTTON
      #ENDENABLE
    #ENDTAB
    #TAB('   ')
      #BOXED('')
        #DISPLAY(' APP')
        #DISPLAY(' 1.03      ( 2005 .)')
      #ENDBOXED
      #BOXED('')
        #DISPLAY('    ')
        #DISPLAY('APP   TXA/TXD.')
        #DISPLAY
        #DISPLAY('    ')
        #DISPLAY('    PATH.')
      #ENDBOXED
      #BOXED(''),SECTION
        #DISPLAY(' :'),AT(10, 5)
        #DISPLAY(' ..'),AT(70, 5)
        #DISPLAY(' '),AT(70, 15)
        #DISPLAY(' :'),AT(10, 25)
        #DISPLAY(' '),AT(70, 25)
      #ENDBOXED
    #ENDTAB
  #ENDSHEET
#!-----------------------------------------------------------------------------------------------------------
#ATSTART
  #IF(%DictionaryFile AND %DictionaryChanged)
      #SET(%AutoSaverDctFlag, %True)
  #ENDIF
#ENDAT
#!-----------------------------------------------------------------------------------------------------------
#ATEND
  #IF(%AutoSaverActive AND ~%EditProcedure AND (%AutoSaverDctFlag OR %AutoSaverEvery = '1' OR %AutoSaverEveryDate <> TODAY() OR CLOCK() < %AutoSaverEveryTime OR ((CLOCK() - %AutoSaverEveryTime) / 6000) > %AutoSaverEveryMin) AND %IsWriteMode())
    #!
    #DECLARE(%AutoSaverFlag, LONG)
    #SET(%AutoSaverFlag, %True)
    #FOR(%Module),WHERE(INSTRING('GENERATED', %ModuleTemplate, 1, 1) = 1)
      #IF(%GenerationCompleted = %False)
        #SET(%AutoSaverFlag, %False)
        #BREAK
      #ENDIF
    #ENDFOR
    #!
    #IF(%AutoSaverFlag)
       #!    ,   TXA/TXD
       #!
       #SET(%AutoSaverEveryDate, TODAY())
       #SET(%AutoSaverEveryTime, CLOCK())
       #!
       #!   TXA  TXD 
       #DECLARE(%AutoSaverTxaFile)
       #SET(%AutoSaverTxaFile, %Application & '_' & FORMAT(TODAY(), @D05-) & '_' & FORMAT(CLOCK(), @T04-))
       #!
       #DECLARE(%AutoSaverTxdFile)
       #IF(%AutoSaverDctFlag AND %DictionaryFile)
         #SET(%AutoSaverTxdFile, CLIP(%AutoSaverTxaFile) & '.txd')
       #ELSE
         #SET(%AutoSaverTxdFile, '')
       #ENDIF
       #SET(%AutoSaverTxaFile, CLIP(%AutoSaverTxaFile)  & '.txa')
       #SET(%AutoSaverDctFlag, %False)
       #!
       #MESSAGE('', 0)
       #MESSAGE(' TXA : ' & %Application,      1)
       #MESSAGE('         : ' & %AutoSaverTxaFile, 2)
       #!
       #SECTION
       #CREATE(%AutoSaverTxaFile)
       #EXPORT
       #CLOSE(%AutoSaverTxaFile)
       #ENDSECTION
       #!
       #IF(%AutoSaverTxdFile)
         #MESSAGE('', 0)
         #MESSAGE(' TXD : ' & %Application,      1)
         #MESSAGE('         : ' & %AutoSaverTxdFile, 2)
         #!
         #SECTION
         #CREATE(%AutoSaverTxdFile)
         #EXPORT(%DictionaryFile)
         #CLOSE(%AutoSaverTxdFile)
         #ENDSECTION
       #ENDIF
       #!
       #!   %TxaFolder, %TxdFolder, %AppFolder
       #!
       #DECLARE(%AutoSaverTxaFolder)                       #! %TxaFolder
       #DECLARE(%AutoSaverTxdFolder)                       #! %TxdFolder
       #DECLARE(%AutoSaverAppFolder)                       #! %AppFolder
       #DECLARE(%AutoSaverFileList)                        #! %FileList
       #!
       #SET(%AutoSaverTxaFolder, %GetFolder(%AutoSaverTxaFile))
       #SET(%AutoSaverTxdFolder, %GetFolder(%AutoSaverTxdFile))
       #SET(%AutoSaverAppFolder, %GetFolder(%Application))
       #!
       #IF(%AutoSaverAppFolder)
         #!
         #SET(%AutoSaverFileList, CLIP(%AutoSaverAppFolder) & 'AppAutoSaver.lst')
         #!
         #SECTION
         #CREATE(%AutoSaverFileList)
         #IF(%AutoSaverTxaFile)
%AutoSaverTxaFolder%AutoSaverTxaFile
         #ENDIF
         #IF(%AutoSaverTxdFile)
%AutoSaverTxdFolder%AutoSaverTxdFile
         #ENDIF
         #CLOSE(%AutoSaverFileList)
         #ENDSECTION
         #!
         #!
         #!  
         #!
         #DECLARE(%AutoSaverRun)
         #!
         #FOR(%AutoSaverRunCmdAll)
           #SET(%AutoSaverRun, CLIP(%AutoSaverRunCmd))
           #!
           #SET(%AutoSaverRun, %ReplaceMetasymbol(%AutoSaverRun, '%TxaFile',   CLIP(%AutoSaverTxaFile)))
           #SET(%AutoSaverRun, %ReplaceMetasymbol(%AutoSaverRun, '%TxaFolder', CLIP(%AutoSaverTxaFolder)))
           #SET(%AutoSaverRun, %ReplaceMetasymbol(%AutoSaverRun, '%TxdFile',   CLIP(%AutoSaverTxdFile)))
           #SET(%AutoSaverRun, %ReplaceMetasymbol(%AutoSaverRun, '%TxdFolder', CLIP(%AutoSaverTxdFolder)))
           #SET(%AutoSaverRun, %ReplaceMetasymbol(%AutoSaverRun, '%AppName',   CLIP(%Application)))
           #SET(%AutoSaverRun, %ReplaceMetasymbol(%AutoSaverRun, '%AppFolder', CLIP(%AutoSaverAppFolder)))
           #SET(%AutoSaverRun, %ReplaceMetasymbol(%AutoSaverRun, '%FileList',  CLIP(%AutoSaverFileList)))
           #!
           #!  
           #IF(%AutoSaverRun)
             #RUN(%AutoSaverRun)
           #ENDIF
         #ENDFOR
       #ENDIF
    #ENDIF
  #ENDIF
#ENDAT
#!***********************************************************************************************************
#GROUP(%IsWriteMode)                   #!      
#!-----------------------------------------------------------------------------------------------------------
  #SECTION
  #CREATE('WRITE$$MODE.TMP')
WRITE$$MODE
  #CLOSE('WRITE$$MODE.TMP')
  #ENDSECTION
  #!
  #IF(FILEEXISTS('WRITE$$MODE.TMP'))
    #REMOVE('WRITE$$MODE.TMP')
    #RETURN(%True)
  #ELSE
    #RETURN(%False)
  #ENDIF
#!***********************************************************************************************************
#GROUP(%ResetRunCmd)                   #!  
#!-----------------------------------------------------------------------------------------------------------
  #PURGE(%AutoSaverRunCmdAll)
  #ADD(%AutoSaverRunCmdAll, 1)
  #SET(%AutoSaverRunCmd,'WinRar.exe a -u -s -df -y -ibck -ag_MM_YY %AppName @%FileList')
#!***********************************************************************************************************
#GROUP(%GetFolder, %SaveFileName)
#!-----------------------------------------------------------------------------------------------------------
  #DECLARE(%AutoSaverFolder)
  #DECLARE(%AutoSaverFolderPos, LONG)
  #!
  #SET(%AutoSaverFolder, FULLNAME(%SaveFileName))
  #LOOP,FOR(%AutoSaverFolderPos, LEN(%AutoSaverFolder), 1),BY(-1)
    #IF(SUB(%AutoSaverFolder, %AutoSaverFolderPos, 1) = '\')
      #RETURN(SUB(%AutoSaverFolder, 1, %AutoSaverFolderPos))
    #ENDIF
  #ENDLOOP
  #!
  #RETURN('')
#!***********************************************************************************************************
#GROUP(%ReplaceMetasymbol, %OrigStr, %FromData, %ToData)
#!-----------------------------------------------------------------------------------------------------------
  #IF(%OrigStr)
    #DECLARE(%AutoSaverFindPos, LONG)
    #SET(%AutoSaverFindPos, INSTRING(UPPER(%FromData),UPPER(%OrigStr),1,1))
    #IF(%AutoSaverFindPos)
      #IF(%ToData)
        #RETURN(SUB(%OrigStr, 1, %AutoSaverFindPos - 1) & %ToData & SUB(%OrigStr, %AutoSaverFindPos + LEN(%FromData), LEN(%OrigStr) - %AutoSaverFindPos - LEN(%FromData) + 1))
      #ELSE
        #RETURN('')
      #ENDIF
    #ENDIF
  #ENDIF
  #!
  #RETURN(%OrigStr)
#!***********************************************************************************************************
